
#include "lista.cpp"

class Problema {
//Declaraciones privadas de la clase
private:
double *p;
double *b;
int tam;
double M;
Nodo *sol;
bool fin;


//Declaraciones publicas de la clase
public:

Problema();
Nodo *generarHermano(Nodo *nodo);
Nodo *aumentarNivel(Nodo *nodo);
Nodo *retrocederNivel(Nodo *nodo);
void tratarSolucion(Nodo *nodo);
bool criterio(Nodo *nodo);
bool masHermanos(Nodo *nodo);
bool condicionParada(Nodo *nodo);
bool solucion(Nodo *nodo);
~Problema();

Problema(double a1,double a2,double a3,double a4,double a5,
		   double p1,double p2,double p3,double p4,double p5);
double calcularPeso(Nodo *nodo);
double calcularBeneficio(Nodo *nodo);
Nodo *getSolucion(){return sol;};
};

Problema::Problema() {
//Vacio

}


Nodo *Problema::generarHermano(Nodo *nodo){

	nodo->solucion[nodo->getNivel()] = nodo->solucion[nodo->getNivel()]++;
	nodo->setPact(calcularPeso(nodo));
	nodo->setBact(calcularBeneficio(nodo));
	return nodo;

}

Nodo *Problema::aumentarNivel(Nodo *nodo) {
	nodo->setNivel(nodo->getNivel()+1);
	return nodo;
}

Nodo *Problema::retrocederNivel(Nodo *nodo) {
	int i;
	
	for ( i = nodo->getNivel();i<tam;i++){
		nodo->solucion[i]=-1;
	}
	nodo->setNivel(nodo->getNivel()-1);
	nodo->setPact(calcularPeso(nodo));
	nodo->setBact(calcularBeneficio(nodo));
	return nodo;
}

void Problema::tratarSolucion(Nodo *nodo) {
	
	if (sol==NULL || (sol!=NULL && nodo->getBact()<sol->getBact()))
		sol->copiar(nodo);

}

bool Problema::criterio(Nodo *nodo){
        if ((nodo->getNivel()!=nodo->getTam()-1) && (nodo->getPact()<=M)) return true;
	return false;
}

bool Problema::masHermanos(Nodo *nodo) {
	if (nodo->solucion[nodo->getNivel()]<1) return true;
	return false;
}

bool Problema::condicionParada(Nodo *nodo){
      if (nodo->getNivel()==-1 || fin ) return true;
	return false;
}
bool Problema::solucion(Nodo *nodo){
        if ((nodo->getNivel()==nodo->getTam()-1) && (nodo->getPact()==M)) return true;
	return false;
}

Problema::~Problema() {

}

//Otras funciones auxiliares

Problema::Problema(double a1,double a2,double a3,double a4,double a5,
		   double p1,double p2,double p3,double p4,double p5) {
	tam = 5;
	sol = new Nodo(5);
	b = new double[tam];
	p = new double[tam];
	
	
	b[0] = a1;b[1] = a2;b[2] = a3; b[3] = a4; b[4] = a5;
	p[0] = p1;p[1] = p2;p[2] = p3; p[3] = p4; p[4] = p5;
	
	M = 8;
	fin = false;
}

double Problema::calcularPeso(Nodo *nodo){

	int i = 0;
	double aux = 0;
	for (i=0;i<nodo->getTam();i++){
		if (nodo->solucion[i]==-1) break;
		aux = aux + nodo->solucion[i]*p[i];	
	}
	return aux;
}

double Problema::calcularBeneficio(Nodo *nodo){
	
	int i = 0;
	double aux = 0;
	for (i=0;i<nodo->getTam();i++){
		if (nodo->solucion[i]==-1) break;
		aux = aux + nodo->solucion[i]*p[i]*b[i];	
	}
	return aux;
}



