#include "lista.cpp"

class Problema {
//Declaraciones privadas de la clase
private:
Lista hijos;
int * procesadores;
int * tareas;
//segundos por instruccion
int nprocesadores;
//instrucciones de la tarea
int ntareas;
int proc_mas_lento;

//Declaraciones publicas de la clase
public:
Problema();
double CS(Nodo *nodo);
double CI(Nodo *nodo);
double coste(Nodo *nodo);
Lista* obtenerHijos(Nodo *nodo);
bool mejorSolucionFinal(Nodo *nodoY, Nodo *nodoS);
double mejor(double x, double y);
bool solucionFinal(Nodo *nodo);
~Problema();
Problema(int p1,int p2,int p3,int t1,int t2,int t3,int t4,int t5,int t6,int t7);

};
Problema::Problema(){

}


double Problema::CS(Nodo *nodo) {
int i = 0,j = 0;
double cs =0,aux=0;

//Para cada procesador
for (i=0;i<nprocesadores;i++){
	aux = 0;
	for (j=0;j<ntareas;j++){
		if (nodo->solucion[j]==i) aux += procesadores[i]*tareas[j];
	}
	if (aux>cs) cs = aux;

}

for (i=0;i<ntareas;i++){
	if (nodo->solucion[i]==-1){
		cs += procesadores[proc_mas_lento]*tareas[i];
	}
}

return cs;

}

double Problema::CI(Nodo *nodo) {
int i = 0,j = 0;
double ci =0,aux=0;

//Para cada procesador
for (i=0;i<nprocesadores;i++){
	aux = 0;
	for (j=0;j<ntareas;j++){
		if (nodo->solucion[j]==i) aux += procesadores[i]*tareas[j];
	}
	if (aux>ci) ci = aux;

}
return ci;

}

double Problema::coste(Nodo *nodo) {
	return ((nodo->getCS()+nodo->getCI())/2);
}

Lista *Problema::obtenerHijos(Nodo *nodo) {
Lista *hijos = new Lista();
int i=0,j=0;
nodo->nivel++;
Nodo *nodo_hijo = new Nodo(ntareas);
nodo_hijo->nivel = nodo->nivel;

for (i=0;i<nprocesadores;i++){

	nodo_hijo->solucion = new int[ntareas];
	for (j=0;j<ntareas;j++)
		nodo_hijo->solucion[j] = nodo->solucion[j];



	nodo_hijo->solucion[nodo_hijo->nivel] = i;
	nodo_hijo->setCI(CI(nodo_hijo));
	nodo_hijo->setCS(CS(nodo_hijo));
	nodo_hijo->setBE(coste(nodo_hijo));

	hijos->Insertar(nodo_hijo);
	//nodo_hijo.mostrar();
}
return hijos;
}

bool Problema::solucionFinal(Nodo *nodo) {
	if (nodo->nivel==ntareas-1) return true;
        return false;


}
bool Problema::mejorSolucionFinal(Nodo *nodoY, Nodo *nodoS){

	if (solucionFinal(nodoY))
	                if (nodoY->getBE()<=nodoS->getBE()) return true;

        return false;

}

double Problema::mejor(double x, double y) {
	if (x<y) return x;
	  return y;
}



Problema::~Problema() {

}

//Otras funciones auxiliares

Problema::Problema(int p1,int p2,int p3,int t1,int t2,int t3,int t4,int t5,int t6,int t7){
int i=0;
	nprocesadores = 3;
	ntareas = 7;
	procesadores = new int[nprocesadores];
	tareas = new int[ntareas];

	procesadores[0] = p1;
	procesadores[1] = p2;
	procesadores[2] = p3;

	proc_mas_lento = 0;
	for (i=0;i<nprocesadores;i++){
		if (procesadores[i]>procesadores[proc_mas_lento]) proc_mas_lento=i;
	}
	
proc_mas_lento = 1;
	tareas[0] = t1;
	tareas[1] = t2;
	tareas[2] = t3;
	tareas[3] = t4;
	tareas[4] = t5;
	tareas[5] = t6;
	tareas[6] = t7;

}



