package modelo;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Properties;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class AccionCompilarPruebasFunciones implements Accion {
	private static final String ACCION_RUTAS ="WEB-INF/rutas.properties";
	public String ejecutar(HttpServletRequest peticion, HttpServletResponse respuesta, ServletContext aplicacion) {
		// TODO Auto-generated method stub
		String sCadena;
		
		 int numPru= Integer.valueOf(peticion.getParameter("numPru"));
		 try
	        {	
			   HttpSession actualSession = peticion.getSession(true);
			   actualSession.setAttribute("numPru", numPru);//Ponemos el numero de pruebas en la sesion
			
			  
			   
			   
			   if ((actualSession.getAttribute("algoritmo")).equals("RYPmini") || (actualSession.getAttribute("algoritmo")).equals("RYPmaxi")){
				  
				   for (int i=0;i<numPru;i++){
					   String codigo = peticion.getParameter("codigoPrueba"+i);
					   String cotaInferior = peticion.getParameter("cotaInferior");
					   String cotaSuperior = peticion.getParameter("cotaSuperior");
					   String beneficio = peticion.getParameter("Beneficio");
					   
					   //creamos un directorio por cada prueba.
					   File directorio = new File(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/");
					   directorio.mkdir();
					   //Creamos los ficheros de cada prueba,en primer lugar el main.cpp
			            FileWriter fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"main.cpp");
			            PrintWriter pw = new PrintWriter(fichero);
			            
			            //Leemos el esquemas del fichero de texto y lo escribimos
			            FileReader esquemaRyP = new FileReader(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("tipoRyP"));
			            BufferedReader bf = new BufferedReader(esquemaRyP);
			            
			            while ((sCadena = bf.readLine())!=null) {
			            	System.out.println(sCadena);
			            	pw.println(sCadena);
			            	}
			            //A�adimos el codigo main que teniamos en la sesion
			           bf.close();
			            pw.println(actualSession.getAttribute("codigoMainRYP"));
			            pw.close();
			            //creamos el fichero nodo.cpp
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"nodo.cpp");
			            pw = new PrintWriter(fichero);
			            pw.print(actualSession.getAttribute("nodoRYP.declaracion"));
			            pw.print(actualSession.getAttribute("nodoRYP.Nodo"));
			            pw.print(actualSession.getAttribute("nodoRYP.delete"));
			            pw.print(actualSession.getAttribute("nodoRYP.otras"));
			            pw.close();
			            //Ahora creamos el problema.cpp
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"problema.cpp");
			            pw = new PrintWriter(fichero);
			            pw.print(actualSession.getAttribute("problemaRYP.declaracion"));
			            pw.print(actualSession.getAttribute("problemaRYP.problema"));
			          		            
			            if (cotaSuperior!=null && cotaSuperior.equals("ok")){
			            	pw.print(codigo);
			            }
			            else{
			            	pw.print(actualSession.getAttribute("problemaRYP.CS"));
			            }
			            if (cotaInferior!=null && cotaInferior.equals("ok")){
			            	pw.print(codigo);
			            }
			            else{
			            	pw.print(actualSession.getAttribute("problemaRYP.CI"));
			            }
			            if (beneficio!=null && beneficio.equals("ok")){
			            	pw.print(codigo);
			            }
			            else{
			            	pw.print(actualSession.getAttribute("problemaRYP.coste"));
			            }
			            
			            
			            
			            pw.print(actualSession.getAttribute("problemaRYP.obtenerHijos"));
			            pw.print(actualSession.getAttribute("problemaRYP.mejorSolucionFinal"));
			            pw.print(actualSession.getAttribute("problemaRYP.mejor"));
			            pw.print(actualSession.getAttribute("problemaRYP.solucionFinal"));
			            pw.print(actualSession.getAttribute("problemaRYP.delete"));
			            pw.print(actualSession.getAttribute("problemaRYP.otras"));
			            pw.close();
			            //Ahora creamos la lista, en funcion del tipo de insercion elegido anteriormente
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"lista.cpp");
			            pw = new PrintWriter(fichero);
			            //Leemos de fichero la lista
			            FileReader listaCpp = new FileReader(aplicacion.getRealPath("/") + "/lista.cpp");
				         bf = new BufferedReader(listaCpp);
				            
				            while ((sCadena = bf.readLine())!=null) {
				            	System.out.println(sCadena);
				            	pw.println(sCadena);
				            	}
						//a�adimos el tipo de inserci�n
				         String tipoInsercion = (String)actualSession.getAttribute("tipoInsercion");
				         
				         
						 if (tipoInsercion!=null && tipoInsercion.equals("estrategiaLIFO")){
							 			           
					            pw.println("void Lista::InsertarLNV(Nodo *nodo){");
					            pw.println("Primero();");
					            pw.println("Insertar(nodo);");
					            pw.println("}");
					            
				

						 }
						 if (tipoInsercion!=null && tipoInsercion.equals("estrategiaFIFO")){
							   
							 	pw.println("void Lista::InsertarLNV(Nodo *nodo){");
					            pw.println("int cont = 1;");
					            pw.println("Primero();");
					            pw.println("while (cont<longitud){");
					            pw.println("actual = actual->siguiente;");
					            pw.println("cont++;");
					            pw.println("}");
					            pw.println("Insertar(nodo);");
					            pw.println(" }");
					            
					            	            
						 }
						 if (tipoInsercion!=null && tipoInsercion.equals("lclifo")){
							 //Distinguimos si es maxi o mini.
							 	
								 pw.println("void Lista::InsertarLNV(Nodo *nodo){");
						         pw.println("int cont=1;");
						         pw.println("Nodo aux;");
						         pw.println("Primero();");
						         pw.println("while (cont<longitud){");
						         pw.println("aux = ValorActual();");
						         if (((String)actualSession.getAttribute("algoritmo")).equalsIgnoreCase("RYPmini")) 
								 {
						        	 pw.println("if (nodo->getBE()<=aux->getBE()) break;");
								 }
						         else{
						        	 pw.println("if (nodo->getBE()>=aux->getBE()) break;");
						         }
						         pw.println("actual = actual->siguiente;");
						         pw.println("cont++;");
						         pw.println("}");
						         pw.println("}");
						        
						
							 
						 }
			            
			            
						 pw.close();
						 
			            
				   }
			   }
			   else if ((actualSession.getAttribute("algoritmo")).equals("DYV")){
				   for (int i=0;i<numPru;i++){
					   String codigo = peticion.getParameter("codigoPrueba"+i);
					  
					   
					   //creamos un directorio por cada prueba.
					   File directorio = new File(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/");
					   directorio.mkdir();
					   //Creamos los ficheros de cada prueba,en primer lugar el main.cpp
			            FileWriter fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"main.cpp");
			            PrintWriter pw = new PrintWriter(fichero);
			            
			           
			            pw.println(actualSession.getAttribute("codigoMainDYV"));
			            pw.close();
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"problema.cpp");
			            pw = new PrintWriter(fichero);
			            pw.print(actualSession.getAttribute("problemaDYV.declaracion"));
			            System.out.println(actualSession.getAttribute("problemaDYV.declaracion"));
			            FileReader esquemaRyP = new FileReader(aplicacion.getRealPath("/") + "/"+ "DYV.txt");
			            BufferedReader bf = new BufferedReader(esquemaRyP);
			            
			            while ((sCadena = bf.readLine())!=null) {
			            	//System.out.println(sCadena);
			            	pw.println(sCadena);
			            	}
			            
			           bf.close();
			            pw.print(actualSession.getAttribute("problemaDYV.constructor"));
			            pw.print(actualSession.getAttribute("problemaDYV.pequeno"));
			            pw.print(codigo);
			            
			            pw.print(actualSession.getAttribute("problemaDYV.dividir"));
			            pw.print(actualSession.getAttribute("problemaDYV.combinar"));
			            pw.print(actualSession.getAttribute("problemaDYV.delete"));
			            pw.print(actualSession.getAttribute("problemaDYV.otras"));
			            
			            pw.close();
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"base.cpp");
			            pw = new PrintWriter(fichero);
			            pw.print(actualSession.getAttribute("baseDYV.declaracion")); 
			           // System.out.println(peticion.getAttribute("baseDYV.declaracion"));
			            pw.print(actualSession.getAttribute("baseDYV.constructor"));
			    
			            pw.print(actualSession.getAttribute("baseDYV.delete"));
			            pw.print(actualSession.getAttribute("baseDYV.otras"));
			            
			            pw.close();
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"conjuntosoluciones.cpp");
			            pw = new PrintWriter(fichero);
			            pw.print(actualSession.getAttribute("conjuntosolucionesDYV.declaracion")); 
			            
			            pw.print(actualSession.getAttribute("conjuntosolucionesDYV.constructor"));
			    
			            pw.print(actualSession.getAttribute("conjuntosolucionesDYV.delete"));
			            pw.print(actualSession.getAttribute("conjuntosolucionesDYV.otras"));
			            
			            pw.close();
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"solucion.cpp");
			            pw = new PrintWriter(fichero);
			            pw.print(actualSession.getAttribute("solucionDYV.declaracion")); 
			            
			            pw.print(actualSession.getAttribute("solucionDYV.constructor"));
			            pw.print(actualSession.getAttribute("solucionDYV.mostrar"));
			            pw.print(actualSession.getAttribute("solucionDYV.delete"));
			            pw.print(actualSession.getAttribute("solucionDYV.otras"));
			            
			            pw.close();
			            
				   }
			   }
			   else if ((actualSession.getAttribute("algoritmo")).equals("BACK")){
					  
				   for (int i=0;i<numPru;i++){
					   String codigo = peticion.getParameter("codigoPrueba"+i);
					   String tratarSolucion = peticion.getParameter("tratarSolucion");
					   String criterio = peticion.getParameter("criterio");
					   String condicionParada = peticion.getParameter("condicionParada");
					   
					   //creamos un directorio por cada prueba.
					   File directorio = new File(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/");
					   directorio.mkdir();
					   //Creamos los ficheros de cada prueba,en primer lugar el main.cpp
			            FileWriter fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"main.cpp");
			            PrintWriter pw = new PrintWriter(fichero);
			            
			            //Leemos el esquemas del fichero de texto y lo escribimos
			            FileReader esquemaRyP = new FileReader(aplicacion.getRealPath("/") + "/backtracking.txt");
			            BufferedReader bf = new BufferedReader(esquemaRyP);
			            
			            while ((sCadena = bf.readLine())!=null) {
			            	System.out.println(sCadena);
			            	pw.println(sCadena);
			            	}
			            //A�adimos el codigo main que teniamos en la sesion
			           bf.close();
			            pw.println(actualSession.getAttribute("codigoMainBACK"));
			            pw.close();
			            //creamos el fichero nodo.cpp
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"nodo.cpp");
			            pw = new PrintWriter(fichero);
			            pw.print(actualSession.getAttribute("nodoBACK.declaracion"));
			            pw.print(actualSession.getAttribute("nodoBACK.Nodo"));
			            pw.print(actualSession.getAttribute("nodoBACK.delete"));
			            pw.print(actualSession.getAttribute("nodoBACK.otras"));
			            pw.close();
			            //Ahora creamos el problema.cpp
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"problema.cpp");
			            pw = new PrintWriter(fichero);
			            
			            
			            
			            pw.print(actualSession.getAttribute("problemaBACK.declaracion"));
			            pw.print(actualSession.getAttribute("problemaBACK.problema"));
			            pw.print(actualSession.getAttribute("problemaBACK.generarHermano"));
			            pw.print(actualSession.getAttribute("problemaBACK.aumentarNivel"));
			            pw.print(actualSession.getAttribute("problemaBACK.retrocederNivel"));
			            
			              System.out.println("--------> " + tratarSolucion + "   " + criterio +"  "+ condicionParada);   
			            if (tratarSolucion!=null && tratarSolucion.equals("ok")){
			            	pw.print(codigo);
			            }
			            else{
			            	pw.print(actualSession.getAttribute("problemaBACK.tratarSolucion"));
			            }
			            if (criterio!=null && criterio.equals("ok")){
			            	pw.print(codigo);
			            }
			            else{
			            	pw.print(actualSession.getAttribute("problemaBACK.criterio"));
			            }
			            
			            pw.print(actualSession.getAttribute("problemaBACK.masHermanos"));
			            
			            if (condicionParada!=null && condicionParada.equals("ok")){
			            	pw.print(codigo);
			            }
			            else{
			            	pw.print(actualSession.getAttribute("problemaBACK.condicionParada"));
			            }
			            
			            pw.print(actualSession.getAttribute("problemaBACK.solucion"));
			            pw.print(actualSession.getAttribute("problemaBACK.delete"));
			            pw.print(actualSession.getAttribute("problemaBACK.otras")); 
			            pw.close();
			            
			            //Ahora creamos la lista, en funcion del tipo de insercion elegido anteriormente
			            fichero = new FileWriter(aplicacion.getRealPath("/") + "/"+ actualSession.getAttribute("id") +"/"+actualSession.getAttribute("algoritmo")+"/"+"prueba_"+i+"/"+"lista.cpp");
			            pw = new PrintWriter(fichero);
			            //Leemos de fichero la lista
			            FileReader listaCpp = new FileReader(aplicacion.getRealPath("/") + "/listaBack.cpp");
				         bf = new BufferedReader(listaCpp);
				            
				            while ((sCadena = bf.readLine())!=null) {
				            	System.out.println(sCadena);
				            	pw.println(sCadena);
				            	}
						
			            
			            
						 pw.close();
						 
			            
				   }
			   }
			   
	        }catch(Exception e){
	        	System.out.println(e.toString());
	        }
	        compilar(numPru,peticion,aplicacion);
		return "erroresCompilacionPruebas.jsp";
	}
	
	
	public void compilar(int numPruebas,HttpServletRequest peticion,ServletContext aplicacion){
		HttpSession actualSession = peticion.getSession(true);
		BeanCompilar beanCompilar = new BeanCompilar();
		try{
		for (int i=0;i<numPruebas;i++){
			String direccion = aplicacion.getRealPath("/") + actualSession.getAttribute("id") +"/" + actualSession.getAttribute("algoritmo")+"/prueba_"+i+"/";
			//Cogemos la ruta del g++ del fichero properties
		 	InputStream is = new FileInputStream(aplicacion.getRealPath("/") + ACCION_RUTAS);
			Properties props = new Properties();
			props.load(is);
			String strRuta = props.getProperty("g++1");
			
			Process proc = Runtime.getRuntime().exec (strRuta+" -o "+direccion+"salida "+direccion+"main.cpp");
		 	StreamGobbler errorGobbler = new 
		 	StreamGobbler(proc.getErrorStream(), "");            
		 	StreamGobbler outputGobbler = new 
		 	StreamGobbler(proc.getInputStream(), "");
		 	errorGobbler.start();
		 	outputGobbler.start();
		 	System.out.println(proc.waitFor());
		 	System.out.println("Completado");
		 	System.out.println("Salida: " + proc.exitValue());
		 	
		 	while (errorGobbler.isAlive()) {}
		 	String aux = errorGobbler.getValor();
            String []  aux1 = aux.split("<br>");
            String result="";
            
            for (int j=0;j<aux1.length;j++) {
                    String s = aux1[j];
                    String [] aux2 = s.split("/");                                        
                    result=result+"<br>"+aux2[aux2.length-1];
            }
            beanCompilar.setErrores(result);
        	while (outputGobbler.isAlive()) {}
		 	beanCompilar.setSalida(outputGobbler.getValor());
		 	if (proc.exitValue()==1) {
		 		
		 			beanCompilar.setCompilado("Incorrecta-prueba:"+(i+1)); 
		 			actualSession.setAttribute("beanCompilar", beanCompilar);
				 	actualSession.setAttribute("Compilado", beanCompilar.getCompilado());
		 			break;
		 	}
		 	else  {
		 		
		 		beanCompilar.setCompilado("Correcta");
		 		actualSession.setAttribute("beanCompilar", beanCompilar);
			 	actualSession.setAttribute("Compilado", beanCompilar.getCompilado());
		 	}
		 	
		 	
		}
		
		
		} catch (IOException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
	}
	
	
}