package modelo;

import java.io.FileReader;
import java.io.IOException;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.data.time.Day;
import java.io.File;
import org.jfree.chart.plot.*;
import java.util.*;

import java.io.*;
import org.jfree.data.category.DefaultCategoryDataset;

public class AccionEjecutarPruebasFunciones implements Accion {

	public String ejecutar(HttpServletRequest peticion,
		HttpServletResponse respuesta, ServletContext aplicacion) {
	
		String tiempos = "";
		String salidas = "";
		boolean excep=false;
		
		try {
			HttpSession actualSession = peticion.getSession(true);
			int numPru = (Integer)actualSession.getAttribute("numPru");
			
			tiempos += "<table title =\"Tiempos de ejecucion\" >\n" +
						"<tr>\n"+
						"<td ></td>\n";
			
			salidas += "<table title =\"Salidas ejecuciones\">\n" +
						"<tr>\n"+
						"<td ></td>\n";
			
			for (int i=0;i<numPru;i++) {
				tiempos += "<td style=\"color:green;font-weight:bold\">&nbsp;&nbsp;Prueba "+i+"&nbsp;&nbsp;</td>\n";
				salidas += "<td style=\"color:green;font-weight:bold\">&nbsp;&nbsp;Prueba "+i+"&nbsp;&nbsp;</td>\n";
			}
			tiempos += "</tr>\n"+
						"<tr>\n" +
						"<td style=\"color:green;font-weight:bold\">Tiempos:</td>";
			salidas += "</tr>\n"+
						"<tr>\n" +
						"<td style=\"color:green;font-weight:bold\">Salidas:</td>";
			
			BeanEjecutar beanEjecutar = new BeanEjecutar();
			DefaultCategoryDataset dataset = new DefaultCategoryDataset();
			DefaultCategoryDataset dataset2 = new DefaultCategoryDataset();
			for (int i=0;i<numPru;i++) {
				
				tiempos += "<td style='text-align:center'>";
				long ini = System.currentTimeMillis();
				//Process p = Runtime.getRuntime().exec (aplicacion.getRealPath("/") + actualSession.getAttribute("id") +"/" + actualSession.getAttribute("algoritmo") +"/prueba_"+i+"/salida");
				String dir = aplicacion.getRealPath("/") + actualSession.getAttribute("id") +"/" + actualSession.getAttribute("algoritmo") +"/prueba_"+i+"/";
				
				Process p = Runtime.getRuntime().exec (dir+"salida");
				try {
				    FileReader esquemaDYV = new FileReader(aplicacion.getRealPath("/") +"/"+actualSession.getAttribute("id") +"/" + actualSession.getAttribute("algoritmo") +"/entrada.txt");
				    StreamGobbler inputGobbler = new StreamGobbler(p.getOutputStream(),"",esquemaDYV);
				    inputGobbler.start();
					}
					catch (IOException e){
						
					}
				StreamGobbler errorGobbler = new StreamGobbler(p.getErrorStream(), "");            
				StreamGobbler outputGobbler = new StreamGobbler(p.getInputStream(), "");	                
				errorGobbler.start();
				outputGobbler.start();
				
				p.waitFor();
				long fin = System.currentTimeMillis();
				tiempos += (fin - ini) +"ms.</td>\n";
				double valor = Double.parseDouble(""+(fin-ini));
				dataset.setValue(valor, "Tiempos", "P "+i);
				salidas += "<td style='text-align:center'>";
				while (outputGobbler.isAlive()) {}
				String num = "0";
				if (outputGobbler.getValorNumero()!=null && !outputGobbler.getValorNumero().equals("")){
					
					num = outputGobbler.getValorNumero();
					
				}
				
				
				try {
					dataset2.setValue(Double.parseDouble(num), "salidas", "P "+i);
					}catch (Exception e) {
						//Los valores no se pueden pasar a doubles, no son numeros.
						excep=true;
					}
				salidas += num+"</td>\n"; 
				
				errorGobbler.detener();
				outputGobbler.detener();
				
				
				
			}
			
			
			
			JFreeChart chart = ChartFactory.createBarChart("Tiempos Ejecucion",
					"Pruebas", "Tiempo", dataset, 
					PlotOrientation.VERTICAL, false, true, false);
			JFreeChart chart2 = null;
			if (!excep) {
				chart2 = ChartFactory.createBarChart("Salidas Ejecucion",
					"Pruebas", "Salida", dataset2, 
					PlotOrientation.VERTICAL, false, true, false);
			}
			
			
			try {
				
				ChartUtilities.saveChartAsPNG(new File(aplicacion.getRealPath("/")+actualSession.getAttribute("id") +"/" + actualSession.getAttribute("algoritmo")+ "/imagen1.PNG"), chart, 400,250);
				if (!excep) ChartUtilities.saveChartAsPNG(new File(aplicacion.getRealPath("/")+actualSession.getAttribute("id") +"/" + actualSession.getAttribute("algoritmo")+ "/imagen2.PNG"), chart2, 400,250);
				
				} catch (IOException e) {
				System.err.println("Error creando grafico.");
				} 
				
				String imagen = actualSession.getAttribute("id") +"/" + actualSession.getAttribute("algoritmo")+ "/imagen1.PNG";
				String imagen2 = actualSession.getAttribute("id") +"/" + actualSession.getAttribute("algoritmo")+ "/imagen2.PNG";
				
				tiempos += "</tr></table>\n";
				tiempos += 	"<br><img src=\""+imagen+"\"><br>";
	 						 
				
				
				salidas += "</tr>\n" +
							"</table>\n";
				
				if (!excep)salidas += 	"<br><img src=\""+imagen2+"\"><br>";
				
			
			
			
			
			
		
			
	             
	            beanEjecutar.setSalida(tiempos+"<br><br>"+salidas);
	            
			
	            actualSession.setAttribute("beanEjecutar", beanEjecutar);

	            
	            
	            
	            
	            
		} catch (IOException e) {
			e.printStackTrace();
	} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


		return "ejecutarGraficas.jsp";
	}
}
